<template>
	<div class="login">
		<h2>Se connecter à son compte administrateur</h2>
		<form>
			<label for="email">
				<input
					id="email"
					v-model="email"
					name="email"
					placeholder="Email"
					required
					type="email" />
			</label>
			<label for="password">
				<input
					id="password"
					v-model="password"
					name="password"
					placeholder="Mot de passe"
					required
					type="password" />
			</label>
			<button
				type="submit"
				@click="submitForm">
				Connexion
			</button>
		</form>
	</div>
</template>

<script lang="ts">
	import { defineComponent } from "vue"
	import type { loginReturn } from "@/composables/useUser.composable"
	import { useUser } from "@/composables/useUser.composable"
	import type { Error } from "#/error"

	const errorHandler = (error: Error | null) => {
		if (!error) return
		alert(error.message)
	}

	const verifyLoginInfo = (email: string, password: string) => {
		if (!email || !password || email === "" || password === "" || email == null || password == null || typeof email !== "string" || typeof password !== "string") {
			alert("Missing email or password")
			return false
		}
		if (password.length < 8) {
			alert("Password must be at least 8 characters long")
			return false
		}

		if (email.match(/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/) == null) {
			// regex for email validation (alphanumeric, dot, underscore, dash, @, dot, 2-4 letters)
			alert("Invalid email address")
			return false
		}

		return true
	}

	interface DataComponent {
		email: string
		password: string
	}

	export default defineComponent({
		name: "LoginView",
		data(): DataComponent {
			return {
				email: "",
				password: "",
			}
		},
		methods: {
			async submitForm(event: Event) {
				event.preventDefault() // prevent page reload on form submit
				if (verifyLoginInfo(this.email, this.password)) {
					const body = {
						email: this.email,
						password: this.password,
					}
					const user = (await useUser().login(body)) as loginReturn // login user and get response from server using useUser composable
					if (user.valid) {
						alert("You have been logged in")
						location.href = "/choice" // redirect to choice page
					} else {
						errorHandler(user.error) // display error message
					}
				}
			},
		},
	})
</script>

<style lang="scss" scoped>
	.login {
		border: 1px solid #ccc;
		width: 60vw;
		margin: auto;
		text-align: center;

		form {
			width: 40vw;
			margin: 0 auto;
			display: flex;
			padding: 5vw 0;
			align-items: center;
		}
	}
</style>
